//+------------------------------------------------------------------+
//|                                       Williams multi symbols.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    8
#property indicator_minimum    -100
#property indicator_maximum    0

#property indicator_level1     -20
#property indicator_level2     -40
#property indicator_level3     -50
#property indicator_level4     -60
#property indicator_level5     -80

//
//
//
//
//

extern string _           = "parameters";
extern string Symbols     = "AUDUSD;EURUSD;GBPUSD;USDCHF;USDJPY;USDCAD;NZDUSD;CURRENT";
extern int    WPRPeriod   = 500;
extern string TimeFrame   = "current time frame";
extern bool   Interpolate = true;
extern color  colorFrom   = LimeGreen;
extern color  colorMiddle = Gold;
extern color  colorTo     = MediumVioletRed;
extern int    linesWidth  = 0;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];
string aPairs[];
string sPairs[];

//
//
//
//
//

int    timeFrame;
int    totalSymbols;
string IndicatorFileName;
bool   gettingBars = false;
string prefix      = "NA";
string suffix      = "NA";
string shortName;
string labelName;
string indName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
      if (_=="gettingBars")
      {
         gettingBars = true;
         return(0);
      }

      //
      //
      //
      //
      //
      
                                 SetIndexStyle(0,DRAW_LINE,EMPTY,linesWidth,gradientColor(0,4,colorFrom,colorMiddle));
      SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_LINE,EMPTY,linesWidth,gradientColor(1,4,colorFrom,colorMiddle));
      SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_LINE,EMPTY,linesWidth,gradientColor(2,4,colorFrom,colorMiddle));
      SetIndexBuffer(3,buffer4); SetIndexStyle(3,DRAW_LINE,EMPTY,linesWidth,gradientColor(3,4,colorFrom,colorMiddle));
      SetIndexBuffer(4,buffer5); SetIndexStyle(4,DRAW_LINE,EMPTY,linesWidth,gradientColor(1,5,colorMiddle,colorTo));
      SetIndexBuffer(5,buffer6); SetIndexStyle(5,DRAW_LINE,EMPTY,linesWidth,gradientColor(2,5,colorMiddle,colorTo));
      SetIndexBuffer(6,buffer7); SetIndexStyle(6,DRAW_LINE,EMPTY,linesWidth,gradientColor(3,5,colorMiddle,colorTo));
      SetIndexBuffer(7,buffer8); SetIndexStyle(7,DRAW_LINE,EMPTY,linesWidth,gradientColor(4,5,colorMiddle,colorTo));

      //
      //
      //
      //
      //
      
   timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorFileName = WindowExpertName();
   shortName = MakeUniqueName("WPR multi "," - tf : "+TimeFrame+" ("+WPRPeriod+")");
   IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   for (int i=0;i<8;i++) ObjectDelete(shortName+i);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
      
   //
   //
   //
   //
   //

      if (gettingBars) { buffer1[0] = limit; return(0); }
      if (suffix=="NA" || prefix=="NA")
      {
         getPrefixSuffix(prefix,suffix);
         Symbols = StringUpperCase(StringTrimLeft(StringTrimRight(Symbols)));
         if (StringSubstr(Symbols,StringLen(Symbols),1) != ";")
                          Symbols = StringConcatenate(Symbols,";");
     
         //
         //
         //
         //
         //

         int  s = 0; i = StringFind(Symbols,";",s);
         string current;
            while (i > 0)
            {
               current = StringSubstr(Symbols,s,i-s);
               if (current=="CURRENT")
               {
                  ArrayResize(aPairs,ArraySize(aPairs)+1);
                              aPairs[ArraySize(aPairs)-1] = Symbol();
               }
               if (findSymbol(prefix+current+suffix) && Symbol()!=(prefix+current+suffix)) 
               {
                  ArrayResize(aPairs,ArraySize(aPairs)+1);
                              aPairs[ArraySize(aPairs)-1] = current;
               }                        
               s = i + 1;
               i = StringFind(Symbols,";",s);
            }
         totalSymbols = MathMin(ArraySize(aPairs),8);
      
         //
         //
         //
         //
         //
      
         ArrayResize(sPairs,totalSymbols);
         for (i=0; i<totalSymbols; i++)
         {
            SetIndexLabel(i,labelName+" "+aPairs[i]);
            sPairs[i] = prefix+aPairs[i]+suffix;
         }         
      }      

      //
      //
      //
      //
      //
   
      limit = MathMax(limit,timeFrame/Period());
      int window = WindowFind(shortName);
      for (i=0; i<totalSymbols;i++)
      {
         limit = MathMax(limit,MathMin(Bars-1,iCustom(sPairs[i],timeFrame,IndicatorFileName,"gettingBars",0,0)*timeFrame/Period()));
         if (ObjectFind(shortName+i) == -1)
         {
               ObjectCreate(shortName+i,OBJ_LABEL,window,0,0);
                  ObjectSet(shortName+i,OBJPROP_XDISTANCE,10);
                  ObjectSet(shortName+i,OBJPROP_YDISTANCE,10+i*14);
                  ObjectSet(shortName+i,OBJPROP_CORNER,1);
                  
                  color theColor;
                  switch(i)
                  {
                     case 0: theColor = gradientColor(0,4,colorFrom,colorMiddle); break;
                     case 1: theColor = gradientColor(1,4,colorFrom,colorMiddle); break;
                     case 2: theColor = gradientColor(2,4,colorFrom,colorMiddle); break;
                     case 3: theColor = gradientColor(3,4,colorFrom,colorMiddle); break;
                     case 4: theColor = gradientColor(1,5,colorMiddle,colorTo);   break;
                     case 5: theColor = gradientColor(2,5,colorMiddle,colorTo);   break;
                     case 6: theColor = gradientColor(3,5,colorMiddle,colorTo);   break;
                     case 7: theColor = gradientColor(4,5,colorMiddle,colorTo);   break;
                  }
                  ObjectSetText(shortName+i,aPairs[i],10,"Courier new bold",theColor);
            }
      }            

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      int y;
      if (totalSymbols>0) { y = iBarShift(sPairs[0],timeFrame,Time[i]); buffer1[i] = iWPR(sPairs[0],timeFrame,WPRPeriod,y); }
      if (totalSymbols>1) { y = iBarShift(sPairs[1],timeFrame,Time[i]); buffer2[i] = iWPR(sPairs[1],timeFrame,WPRPeriod,y); }
      if (totalSymbols>2) { y = iBarShift(sPairs[2],timeFrame,Time[i]); buffer3[i] = iWPR(sPairs[2],timeFrame,WPRPeriod,y); }
      if (totalSymbols>3) { y = iBarShift(sPairs[3],timeFrame,Time[i]); buffer4[i] = iWPR(sPairs[3],timeFrame,WPRPeriod,y); }
      if (totalSymbols>4) { y = iBarShift(sPairs[4],timeFrame,Time[i]); buffer5[i] = iWPR(sPairs[4],timeFrame,WPRPeriod,y); }
      if (totalSymbols>5) { y = iBarShift(sPairs[5],timeFrame,Time[i]); buffer6[i] = iWPR(sPairs[5],timeFrame,WPRPeriod,y); }
      if (totalSymbols>6) { y = iBarShift(sPairs[6],timeFrame,Time[i]); buffer7[i] = iWPR(sPairs[6],timeFrame,WPRPeriod,y); }
      if (totalSymbols>7) { y = iBarShift(sPairs[7],timeFrame,Time[i]); buffer8[i] = iWPR(sPairs[7],timeFrame,WPRPeriod,y); }

      //
      //
      //
      //
      //
      
      if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
      if (!Interpolate) continue;
        
      //
      //
      //
      //
      //

      datetime	time = iTime(NULL,timeFrame,y);
      for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
           double factor = 1.0 / n;
           for(int k = 1; k < n; k++)
           {
               if (totalSymbols>0) buffer1[i+k] = k*factor*buffer1[i+n] + (1.0-k*factor)*buffer1[i];
               if (totalSymbols>1) buffer2[i+k] = k*factor*buffer2[i+n] + (1.0-k*factor)*buffer2[i];
               if (totalSymbols>2) buffer3[i+k] = k*factor*buffer3[i+n] + (1.0-k*factor)*buffer3[i];
               if (totalSymbols>3) buffer4[i+k] = k*factor*buffer4[i+n] + (1.0-k*factor)*buffer4[i];
               if (totalSymbols>4) buffer5[i+k] = k*factor*buffer5[i+n] + (1.0-k*factor)*buffer5[i];
               if (totalSymbols>5) buffer6[i+k] = k*factor*buffer6[i+n] + (1.0-k*factor)*buffer6[i];
               if (totalSymbols>6) buffer7[i+k] = k*factor*buffer7[i+n] + (1.0-k*factor)*buffer7[i];
               if (totalSymbols>7) buffer8[i+k] = k*factor*buffer8[i+n] + (1.0-k*factor)*buffer8[i];
           }             
      
   }                           
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

//
//
//
//
//
string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
          else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
         lenght--;
   }
   return(s);
}

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   for(int l = StringLen(tfs)-1; l >= 0; l--)
   {
      int char = StringGetChar(tfs,l);
          if((char > 96 && char < 123) || (char > 223 && char < 256))
               tfs = StringSetChar(tfs, l, char - 32);
          else 
              if(char > -33 && char < 0)
                  tfs = StringSetChar(tfs, l, char + 224);
   }

   //
   //
   //
   //
   //
   
   int tf=0;
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
   tf = MathMax(Period(),tf);         
   return(tf);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#import "kernel32.dll"
    int _lclose (int);
    int _lopen  (string,int);
    int _llseek (int,int,int);
    int _lread  (int,string,int);
#import
#define sectorSize  1936
#define HFILE_ERROR -1
string  symbols[];

//
//
//
//
//

void getSymbolsList()
{
   ArrayResize(symbols,0);
   int fileHandle = _lopen(TerminalPath()+"\\history\\"+AccountServer()+"\\symbols.raw",0);
   if (fileHandle == HFILE_ERROR) return;
    
   //
   //
   //
   //
   //

   for(int i=0;; i++)
   {
      _llseek(fileHandle, i * sectorSize, 0);
      string symbolName = "123456789012";       
                        if (_lread (fileHandle, symbolName, 12) != 12) break;
             symbolName = StringSubstr(symbolName, 0);

             //
             //
             //
             //
             //

      ArrayResize(symbols,i+1); symbols[i] = StringTrimLeft(StringTrimRight(symbolName));
   } 
   _lclose(fileHandle);
}

//
//
//
//
//

bool findSymbol(string findWhat)
{
   int  limit = ArraySize(symbols);
         for(int i=0; i<limit; i++) if (findWhat==symbols[i]) break;
   return(i<limit);      
}
void getPrefixSuffix(string& prefix, string& suffix)
{ 
   getSymbolsList();   
   int limit = ArraySize(symbols);
   if (limit<1) return;
         prefix="";
         suffix="";
   
   //
   //
   //
   //
   //
   
   for(int i=0; i<limit; i++)
   {
      string symbolName = symbols[i];
             int pos = StringFind(symbolName,"EURUSD",0);
             if (pos > -1)
             {
                if (pos>0)                         prefix = StringSubstr(symbolName,0,pos);
                if ((pos+6)<StringLen(symbolName)) suffix = StringSubstr(symbolName,(pos+6),0);
                break;
             }
   } 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}